#include <u.h>
#include <libelf.h>
#include <libdwarf.h>
#include <dwarf.h>

#include "dat.h"

DwarfCompileUnit	*compileunits;

DwarfCompileUnit*
mkdwarfcompileunit(void)
{
	DwarfCompileUnit *cu;

	cu = malloc(sizeof *cu);
	memset(cu, 0, sizeof *cu);
	cu->link = compileunits;
	compileunits = cu;
	return cu;
}

void
dwarfcompileunitclear(Dwarf_Debug dbg, DwarfCompileUnit *cu)
{
	int i;

	if(cu->srcs == nil)
		return;

	for(i=0; i<cu->nsrcs; i++)
			dwarf_dealloc(dbg, cu->srcs[i], DW_DLA_STRING);
	dwarf_dealloc(dbg, cu->srcs, DW_DLA_LIST);
	dwarf_srclines_dealloc(dbg, cu->lines, cu->nlines);
	return;
}

DwarfName*
dwarfname(int tag)
{
	int i;

	for(i=0; dwarfnametab[i].tag != -1; i++)
		if(dwarfnametab[i].tag == tag)
			return &dwarfnametab[i];
	return nil;
}

DwarfOpName*
dwarfopname(int op)
{
	int i;

	for(i=0; dwarfopnametab[i].op != -1; i++)
		if(dwarfopnametab[i].op == op)
			return &dwarfopnametab[i];
	return nil;
}

DwarfTagName*
dwarftagname(int tag)
{
	int i;

	for(i=0; dwarftagnametab[i].tag != -1; i++)
		if(dwarftagnametab[i].tag == tag)
			return &dwarftagnametab[i];
	return nil;
}

DwarfAttrName*
dwarfattrname(int tag)
{
	int i;

	for(i=0; dwarfattrnametab[i].tag != -1; i++)
		if(dwarfattrnametab[i].tag == tag)
			return &dwarfattrnametab[i];
	return nil;
}
