#include <u.h>
#include <stdio.h>
#include <libdwarf.h>
#include <dwarf.h>
#include "dat.h"

s64int
dwarfgetsigned64(uchar *buf, uchar *ebuf)
{
	s64int x;

	if(ebuf-buf < 8){
		fprintf(stderr, "buggered signed 64-bit value\n");
		return 0;
	}
	x = *((s64int*)buf);
	return x;
}

s32int
dwarfgetsigned32(uchar *buf, uchar *ebuf)
{
	s32int x;

	if(ebuf-buf < 4){
		fprintf(stderr, "buggered signed 32-bit value\n");
		return 0;
	}
	x = *((s32int*)buf);
	return x;
}

s16int
dwarfgetsigned16(uchar *buf, uchar *ebuf)
{
	s16int x;

	if(ebuf-buf < 2){
		fprintf(stderr, "buggered signed 16-bit value\n");
		return 0;
	}
	x = *((s16int*)buf);
	return x;
}

s8int
dwarfgetsigned8(uchar *buf, uchar *ebuf)
{
	s8int x;

	if(ebuf-buf < 1){
		fprintf(stderr, "buggered signed 8-bit value\n");
		return 0;
	}
	x = *((s8int*)buf);
	return x;
}

u64int
dwarfgetunsigned64(uchar *buf, uchar *ebuf)
{
	u64int x;

	if(ebuf-buf < 8){
		fprintf(stderr, "buggered unsigned 64-bit value\n");
		return 0;
	}
	x = *((u64int*)buf);
	return x;
}

u32int
dwarfgetunsigned32(uchar *buf, uchar *ebuf)
{
	u32int x;

	if(ebuf-buf < 4){
		fprintf(stderr, "buggered unsigned 32-bit value\n");
		return 0;
	}
	x = *((u32int*)buf);
	return x;
}

u16int
dwarfgetunsigned16(uchar *buf, uchar *ebuf)
{
	u16int x;

	if(ebuf-buf < 2){
		fprintf(stderr, "buggered unsigned 16-bit value\n");
		return 0;
	}
	x = *((u16int*)buf);
	return x;
}

u8int
dwarfgetunsigned8(uchar *buf, uchar *ebuf)
{
	u8int x;

	if(ebuf-buf < 1){
		fprintf(stderr, "buggered unsigned 8-bit value\n");
		return 0;
	}
	x = *((u8int*)buf);
	return x;
}

