#ifndef _U_H_
#define _U_H_ 1
#if defined(__cplusplus)
extern "C" {
#endif

#undef nil
#define nil ((void*)0)

/* command line */
extern char	*argv0;
#define	ARGBEGIN	for((argv0?0:(argv0=*argv)),argv++,argc--;\
			    argv[0] && argv[0][0]=='-' && argv[0][1];\
			    argc--, argv++) {\
				char *_args, *_argt;\
				char _argc;\
				_args = &argv[0][1];\
				if(_args[0]=='-' && _args[1]==0){\
					argc--; argv++; break;\
				}\
				_argc = 0;\
				while(*_args && (_argc=*_args++))\
				switch(_argc)

#define	ARGEND		SET(_argt);USED(_argt);USED(_argc);USED(_args);}USED(argv);USED(argc);
#define ARGOPT()	(_argt=_args, _args=(char*)"", *_argt?_argt:nil)
#define	ARGF()		(_argt=_args, _args=(char*)"",\
				(*_argt? _argt: argv[1]? (argc--, *++argv): 0))
#define	EARGF(x)	(_argt=_args, _args=(char*)"",\
				(*_argt? _argt: argv[1]? (argc--, *++argv): ((x), abort(), (char*)0)))

#define	ARGC()		_argc

/* compiler directives on plan 9 */
#define	SET(x)	((x)=0)
#define	USED(x)	if(x){}else{}
#ifdef __GNUC__
#if __GNUC__ >= 3
#undef USED
#define USED(x) { ulong y __attribute__ ((unused)); y = (ulong)x; }
#endif
#define getcallerpc(x)	((uintptr)__builtin_return_address(0))
#else
ulong			getcallerpc(void*);
#endif

#if defined(__sun__)
#	define __EXTENSIONS__ 1 /* SunOS */
#	if defined(__SunOS5_6__) || defined(__SunOS5_7__) || defined(__SunOS5_8__)
		/* NOT USING #define __MAKECONTEXT_V2_SOURCE 1 / * SunOS */
#	else
#		define __MAKECONTEXT_V2_SOURCE 1
#	endif
#if	defined(__cplusplus)
#	include <wchar.h>		/* SunOS+gcc bug */
#endif
#endif
#if defined(__FreeBSD__)
	/* for strtoll */
#	define __BSD_VISIBLE		1
#	undef __ISO_C_VISIBLE
#	define __ISO_C_VISIBLE		1999
#	undef __LONG_LONG_SUPPORTED
#	define __LONG_LONG_SUPPORTED
#endif
#if defined(__NetBSD__)
#	define _NETBSD_SOURCE		1
#endif
#if defined(__linux__)
#	define _GNU_SOURCE
#	define _FILE_OFFSET_BITS 64
#endif
#define _LARGEFILE64_SOURCE 1
/*#define _SVID_SOURCE */
#define _BSD_SOURCE 1
#if !defined(__APPLE__) && !defined(__OpenBSD__)
#	undef  _XOPEN_SOURCE
#	define _XOPEN_SOURCE 1000
#	define _XOPEN_SOURCE_EXTENDED 1
#endif

#include <inttypes.h>
#include <sys/param.h>
#include <sys/uio.h>
#include <unistd.h>
#include <limits.h>

#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <fcntl.h>
#include <assert.h>
#include <setjmp.h>
#include <stddef.h>
#include <math.h>	/* XXX: doesn't quite work under FreeBSD 4.x */
#include <ctype.h>	/* for tolower */

/*
 * OS-specific crap
 */
#define _NEEDUCHAR 1
#define _NEEDUSHORT 1
#define _NEEDUINT 1
#define _NEEDULONG 1

#define _HAVETIMEGM 1
#define _HAVETMZONE 1
#define _HAVETMTZOFF 1

#if defined(__linux__)
#	include <time.h>
#	include <sys/time.h>
#	include <sys/types.h>
#	include <inttypes.h>
#	define PLAN9_PTHREADS 1
#	if defined(__USE_MISC)
#		undef _NEEDUSHORT
#		undef _NEEDUINT
#		undef _NEEDULONG
#	endif
#	undef MAXFLOAT
#	define	MAXFLOAT	((float)3.40282346638528860e+38)
#	undef _HAVETMZONE
#	undef _HAVETMTZOFF
#define _HAVEPTHREAD_YIELD
	extern	int	pthread_yield(void) __THROW;
#define __XSTRING(x)	__STRING(x)
#endif
#if defined(__sun__)
#	include <strings.h>
#	include <sys/time.h>
#	include <sys/types.h>
#	define PLAN9_PTHREADS 1
#	undef _NEEDUSHORT
#	undef _NEEDUINT
#	undef _NEEDULONG
#	undef _HAVETIMEGM
#	undef _HAVETMZONE
#	undef _HAVETMTZOFF
#define __STRING(x)	#x
#define __XSTRING(x)	__STRING(x)
#endif
#if defined(__FreeBSD__)
#	include <sys/time.h>
#	include <sys/types.h>
#	define PLAN9_PTHREADS 1
#	if !defined(_POSIX_SOURCE)
#		undef _NEEDUSHORT
#		undef _NEEDUINT
#	endif
#define _HAVEPTHREAD_YIELD
#endif
#if defined(__OpenBSD__)
#	include <sys/time.h>
#	include <sys/types.h>
#	define PLAN9_PTHREADS 1
#	if !defined(_POSIX_SOURCE)
#		undef _NEEDUSHORT
#		undef _NEEDUINT
#		undef _NEEDULONG
#	endif
#define _HAVEPTHREAD_YIELD
#define __XSTRING(x)	__STRING(x)
#endif
#if defined(__NetBSD__)
#	include <sys/time.h>
#	include <sys/types.h>
#	define PLAN9_PTHREADS 1
#	if !defined(_POSIX_SOURCE)
#		undef _NEEDUINT
#		undef _NEEDUSHORT
#		undef _NEEDULONG
#	endif
#	define _NEEDLL
#define __XSTRING(x)	__STRING(x)
#endif
#if defined(__APPLE__)
#	include <sys/time.h>
#	include <sys/types.h>
#	include <strings.h>
#	define PLAN9_PTHREADS 1
#define __XSTRING(x)	__STRING(x)
#define _HAVEPTHREAD_YIELD
#	define pthread_yield()	pthread_yield_np()
#	if __GNUC__ < 4
#		undef _NEEDUSHORT
#		undef _NEEDUINT
#	endif
#	undef _ANSI_SOURCE
#	undef _POSIX_C_SOURCE
#	undef _XOPEN_SOURCE
#	if !defined(NSIG)
#		define NSIG 32
#	endif
#	define _NEEDLL 1
#define __XSTRING(x)	__STRING(x)
#endif

typedef signed char schar;
typedef unsigned int u32int;
typedef int s32int;

#ifdef _NEEDUCHAR
	typedef unsigned char uchar;
#endif
#ifdef _NEEDUSHORT
	typedef unsigned short ushort;
#endif
#ifdef _NEEDUINT
	typedef unsigned int uint;
#endif
#ifdef _NEEDULONG
	typedef unsigned long ulong;
#endif
typedef unsigned long long uvlong;
typedef long long vlong;
typedef uvlong u64int;
typedef vlong s64int;
typedef uchar u8int;
typedef schar s8int;
typedef ushort u16int;
typedef short s16int;

typedef uintptr_t uintptr;

#undef _NEEDUCHAR
#undef _NEEDUSHORT
#undef _NEEDUINT
#undef _NEEDULONG

#if defined(__cplusplus)
}
#endif
#endif
