#include <u.h>
#include "util.h"

char*
estrcat(char *s, const char *t)
{
	char *u;
	int n, m;

	m = strlen(s);
	n = strlen(t);
	u = realloc(s, m+n+1);
	memcpy(u+m, t, n+1);
	return u;
}

#define PRIME		((u32int)0x01000193)
//#define REDUCE(h)	h *= PRIME
#define REDUCE(h)	h += (h<<1)+(h<<4)+(h<<7)+(h<<8)+(h<<24)

inline u32int
hashbytes(uchar *b, int n, u32int h)
{
	uchar *be;

	for(be=b+n; b<be; b++){
		h ^= (u32int)*b;
		REDUCE(h);
	}
	return h;
}

u32int
hash32(u32int x, u32int h)
{
	return hashbytes((uchar*)&x, sizeof(x), h);
}

u32int
hash64(u64int x, u32int h)
{
	return hashbytes((uchar*)&x, sizeof(x), h);
}
